#include "dialogobiestable.h"


#include "constantes.h"

IMPLEMENT_CLASS (DialogoBiestable, Dialogo)
DialogoBiestable::DialogoBiestable()
{
	Init();
}

DialogoBiestable::DialogoBiestable ( 	wxWindow* ventanaPadre, wxWindowID id,
							const wxString& titulo,
							const wxPoint&  posicion,
							const wxSize&   tam,
							long  			estilo ) 
{
		Init();
		Dialogo::Create (ventanaPadre, id, titulo, posicion, tam, estilo);
}

		
void DialogoBiestable::Init()
{
	/*	Aqui se inicializan las variables */
}


void DialogoBiestable::ConstruirControles()
{
	
	  contenedorCentral = new wxBoxSizer(wxVERTICAL);
	
	  contenedorR = new wxBoxSizer(wxHORIZONTAL);
	  lblReposoR = new wxStaticText(this, ID_STATIC, wxT("Voltaje de reposo para la entrada R"), wxDefaultPosition, wxDefaultSize, 0);
	       
	  contenedorR->Add(lblReposoR, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
	  spnVReposoR = new wxSpinCtrl(this, ID_VOLTAJE_REPOSO_R, wxT("0"), wxDefaultPosition, wxSize(45,-1), wxSP_ARROW_KEYS, -10, 10, 0);
	       
	  contenedorR->Add(spnVReposoR, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
	  contenedorR->Add(10, 10, 1, wxALL, 5);
	  lblVoltajeActivacionR = new wxStaticText(this, ID_STATIC, wxT("Voltaje de activacin para R"), wxDefaultPosition, wxDefaultSize, 0);
	       
	  contenedorR->Add(lblVoltajeActivacionR, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
	  spnVActivacionR = new wxSpinCtrl(this, ID_VOLTAJE_ACTIVACION_R, wxT("5"), wxDefaultPosition, wxSize(45,-1), wxSP_ARROW_KEYS, -10, 10, 0);
	       
	  contenedorR->Add(spnVActivacionR, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
	  contenedorCentral->Add(contenedorR, 1, wxEXPAND, 5);
	
	  contenedorS = new wxBoxSizer(wxHORIZONTAL);
	  lblVReposoS = new wxStaticText(this, ID_STATIC, wxT("Voltaje de reposo para la entrada S"), wxDefaultPosition, wxDefaultSize, 0);
	       
	  contenedorS->Add(lblVReposoS, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
	  spnVReposoS = new wxSpinCtrl(this, ID_VOLTAJE_REPOSO_S, wxT("0"), wxDefaultPosition, wxSize(45,-1), wxSP_ARROW_KEYS, -10, 10, 0);
	       
	  contenedorS->Add(spnVReposoS, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
	  contenedorS->Add(10, 10, 1, wxALL, 5);
	  lblActivacionS = new wxStaticText(this, ID_STATIC, wxT("Voltaje de activacin para S"), wxDefaultPosition, wxSize(-1,-1), 0);
	       
	  contenedorS->Add(lblActivacionS, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
	  spnVActivacionS = new wxSpinCtrl(this, ID_VOLTAJE_ACTIVACION_S, wxT("5"), wxDefaultPosition, wxSize(45,-1), wxSP_ARROW_KEYS, -10, 10, 0);
	       
	  contenedorS->Add(spnVActivacionS, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
	  contenedorCentral->Add(contenedorS, 1, wxEXPAND, 5);
	  m_staticline2 = new wxStaticLine(this, ID_STATIC, wxDefaultPosition, wxDefaultSize, wxLI_HORIZONTAL);
	       
	  contenedorCentral->Add(m_staticline2, 0, wxALL|wxEXPAND, 5);
	
	  contenedorQ = new wxBoxSizer(wxHORIZONTAL);
	  lblReposoQ = new wxStaticText(this, ID_STATIC, wxT("Voltaje de reposo para Q"), wxDefaultPosition, wxDefaultSize, 0);
	       
	  contenedorQ->Add(lblReposoQ, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
	  spnVReposoQ = new wxSpinCtrl(this, ID_VOLTAJE_REPOSO_Q, wxT("0"), wxDefaultPosition, wxSize(45,-1), wxSP_ARROW_KEYS, -10, 10, 0);
	       
	  contenedorQ->Add(spnVReposoQ, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
	  contenedorQ->Add(10, 10, 1, wxALL|wxEXPAND, 5);
	  lblVoltajeSalidaQ = new wxStaticText(this, ID_STATIC, wxT("Voltaje de salida para Q activada"), wxDefaultPosition, wxDefaultSize, 0);
	       
	  contenedorQ->Add(lblVoltajeSalidaQ, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
	  spnVActivacionQ = new wxSpinCtrl(this, ID_VOLTAJE_SALIDA_Q, wxT("5"), wxDefaultPosition, wxSize(45,-1), wxSP_ARROW_KEYS, -10, 10, 0);
	       
	  contenedorQ->Add(spnVActivacionQ, 0, wxALL, 5);
	  contenedorCentral->Add(contenedorQ, 1, wxEXPAND, 5);	
	  
	  
	  ConstruirCuadroDeDialogo (contenedorCentral);     
}

/*************************************************/
/* Implementacion de los metodos getter y setter */
/*************************************************/

void DialogoBiestable::getPropiedades ( Elemento* elemento )
{
	Biestable*  biestable= (Biestable*) elemento;
	
	TransferirDeNombreDeElementoAControl (elemento);
	
	/*	Y los controles numricos adoptan el valor de los voltajes respectivos
		del elemento pasado */
	TransferirDeVoltajeASpin ( spnVReposoR, 
			biestable->getEntradaReposoR() );
			
	TransferirDeVoltajeASpin ( spnVActivacionR, 
			biestable->getEntradaActivacionR() );	
			
	TransferirDeVoltajeASpin ( spnVReposoS, 
			biestable->getEntradaReposoS() );
			
	TransferirDeVoltajeASpin ( spnVActivacionS, 
			biestable->getEntradaActivacionS() );	
			
	TransferirDeVoltajeASpin ( spnVReposoQ, 
			biestable->getSalidaReposoQ() );
			
	TransferirDeVoltajeASpin ( spnVActivacionQ, 
			biestable->getSalidaActivacionQ() );	
}

void DialogoBiestable::setPropiedades ( Elemento* elemento )
{
	Biestable*  biestable= (Biestable*) elemento;
	
	TransferirDeControlANombreDeElemento (elemento);
	
	TransferirDeSpinAVoltaje ( spnVReposoR, 
			biestable->getEntradaReposoR() );
			
	TransferirDeSpinAVoltaje( spnVActivacionR, 
			biestable->getEntradaActivacionR() );	
			
	TransferirDeSpinAVoltaje( spnVReposoS, 
			biestable->getEntradaReposoS() );
			
	TransferirDeSpinAVoltaje( spnVActivacionS, 
			biestable->getEntradaActivacionS() );	
			
	TransferirDeSpinAVoltaje( spnVReposoQ, 
			biestable->getSalidaReposoQ() );
			
	TransferirDeSpinAVoltaje( spnVActivacionQ, 
			biestable->getSalidaActivacionQ() );	
	
}		
/*************************************************/
/*	Fin de implementacion de los getter y setter */		
/*************************************************/
