/*	Fichero dialogoelectroiman.h
	
	Contiene el interfaz para el cuadro de dialogo que permite configurar
	un pulsador	
	
	Ultima actualizacion: Sabado 4-11-2006
*/


#ifndef _dialogoelectroiman_h
#define _dialogoelectroiman_h

#include "wx/wx.h"
#include "wx/statline.h"
#include "wx/spinctrl.h"
#include "wx/valgen.h"
/*	Este fichero es necesario para que el cuadro de dialogo pueda manejar
	los mismos tipos de seales que manejan los elementos */
#include "senal.h"

#include "dialogo.h"
#include "electroiman.h"

/* Identificadores numricos asignados a los botones del cuadro de dialogo*/
enum {
	ID_DIALOGO_ELECTROIMAN=7700,
	ID_VOLTAJE_ACTIVACION_ELECTROIMAN,	ID_VOLTAJE_REPOSO_ELECTROIMAN, 
	ID_MAGNETISMO_REPOSO_ELECTROIMAN, ID_MAGNETISMO_ACTIVACION_ELECTROIMAN
};

class DialogoElectroiman : public Dialogo
{
	DECLARE_CLASS (DialogoElectroiman)
	DECLARE_EVENT_TABLE()
	public: 
		DialogoElectroiman ();
		DialogoElectroiman ( 	wxWindow* ventanaPadre, wxWindowID id=ID_DIALOGO_ELECTROIMAN,
							const wxString& titulo= wxT ("Configurar electroiman"),
							const wxPoint&  posicion=wxDefaultPosition,
							const wxSize&   tam=wxDefaultSize,
							long  			estilo=wxCAPTION | 
													wxRESIZE_BORDER |
													wxSYSTEM_MENU );

		
		void ConstruirControles();
		void Init ();

		/* Metodos getter y setter */
		
		/*	Lee el nombre y valores del elemento y los representa en
		el cuadro de dilogo */
		virtual void getPropiedades ( Elemento* elemento );
	
		/*	Hace que un elemento adquiera las propiedades del dilogo */
		virtual void setPropiedades ( Elemento* elemento );
		
		
		void 		OnCReposoActualizado ( wxCommandEvent& evento  );

		void 		OnCActivacionActualizado ( wxCommandEvent& evento  );
	private:
		
		/*	Estos nombres de variable no son del todo representativos,
			ya que el usuario puede invertir los valores y escribir que
			por ejemplo 0V es el voltaje que el pulsador emite cuando se
			pulsa. Se usan estos nombres porque por defecto se usaran
			0V para el reposo y "false" para el estado no-conectado*/
		char	nombreElemento[MAX_LONG_NOMBRE_ELEMENTO];
		
		
		/*	Los controles. */
		wxBoxSizer*	contenedorCentral;
			
			wxBoxSizer*	contenedorReposo;
			wxBoxSizer* contenedorActivacion;
				
		wxStaticText* lblVoltajeReposo;
		wxStaticText* lblVoltajeActivacion;
		wxStaticText* lblMagnetismoReposo;
		wxStaticText* lblMagnetismoActivo;
		
		wxChoice*	chcMagnetismoReposo;
		wxChoice*	chcMagnetismoActivacion;
		
		wxSpinCtrl*	spnVReposo;
		wxSpinCtrl* spnVActivacion;
		
};

#endif
