#include "dialogofotosensor.h"
#include "dialogo.h"
#include "fotosensor.h"
#include "constantes.h"

IMPLEMENT_CLASS (DialogoFotoSensor, Dialogo)
DialogoFotoSensor::DialogoFotoSensor()
{
	Init();
}

DialogoFotoSensor::DialogoFotoSensor ( 	wxWindow* ventanaPadre, wxWindowID id,
							const wxString& titulo,
							const wxPoint&  posicion,
							const wxSize&   tam,
							long  			estilo ) 
{
		Init();
		Dialogo::Create (ventanaPadre, id, titulo, posicion, tam, estilo);
}

		
void DialogoFotoSensor::Init()
{
	/*	Aqui se inicializan las variables */
}


void DialogoFotoSensor::ConstruirControles()
{
	  
	  contenedorCentral = new wxBoxSizer(wxVERTICAL);
	  
	  contenedorReposo = new wxBoxSizer(wxHORIZONTAL);
	  lblLuzReposo = new wxStaticText(this, wxID_STATIC, 
	  		wxT("Cuando el receptor est"), wxDefaultPosition, wxDefaultSize, 0);
	       
	  contenedorReposo->Add(lblLuzReposo, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
	  
	  wxString opciones1[]= {
		wxT("activado"), wxT("desactivado")
	  };
	  chcLuzReposo = new wxChoice (this, ID_LUZ_REPOSO_FOTOSENSOR, 
		wxDefaultPosition, wxDefaultSize, WXSIZEOF(opciones1), 
		opciones1, ESTILO );
	  chcLuzReposo->SetStringSelection ("desactivado");
	  	       
	  contenedorReposo->Add(chcLuzReposo, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
	  
	  lblVoltajeReposo = new wxStaticText(this, wxID_STATIC, 
	  			wxT("el voltaje de salida es"), wxDefaultPosition, wxDefaultSize, 0);
	       
	  contenedorReposo->Add(lblVoltajeReposo, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
	  
	  wxString voltajeEnReposoPorDefecto="0";
	  
	  spnVoltajeReposo = new wxSpinCtrl (this, ID_VOLTAJE_REPOSO_FOTOSENSOR,
		voltajeEnReposoPorDefecto, wxDefaultPosition, wxSize(45,-1),
		wxSP_ARROW_KEYS, VOLTAJE_MINIMO, VOLTAJE_MAXIMO, VOLTAJE_EN_REPOSO);	
	       
	  contenedorReposo->Add(spnVoltajeReposo, 0, 
	  		wxALL|wxALIGN_CENTER_VERTICAL|wxFIXED_MINSIZE, 5);
	  contenedorCentral->Add(contenedorReposo, 1, wxEXPAND, 5);
	  wxBoxSizer *contenedorActivacion;
	  contenedorActivacion = new wxBoxSizer(wxHORIZONTAL);
	  
	  
	  lblLuzActivacion = new wxStaticText(this, wxID_STATIC, 
	  	wxT("Cuando el receptor est"), wxDefaultPosition, wxDefaultSize, 0);
	       
	  contenedorActivacion->Add(lblLuzActivacion, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
	  
	  wxString opciones2[]= {
		wxT("activado"), wxT("desactivado")
	  };
	  chcLuzActivacion = new wxChoice (this, ID_LUZ_ACTIVACION_FOTOSENSOR, 
		wxDefaultPosition, wxDefaultSize, WXSIZEOF(opciones2), 
		opciones1, ESTILO );
	  chcLuzActivacion->SetStringSelection ("activado");
	       
	  contenedorActivacion->Add(chcLuzActivacion, 0, 
	  	wxALL|wxALIGN_CENTER_VERTICAL, 5);
	  
	  lblVoltajeSalida = new wxStaticText(this, wxID_STATIC,
	  		 wxT("el voltaje de salida es"), wxDefaultPosition, wxDefaultSize, 0);
	       
	  contenedorActivacion->Add(lblVoltajeSalida, 0, 
	  	wxALL|wxALIGN_CENTER_VERTICAL, 5);
	  wxString voltajeEnActivacionPorDefecto="5";
	  spnVoltajeActivacion = new wxSpinCtrl (this, ID_VOLTAJE_ACTIVACION_FOTOSENSOR,
		voltajeEnActivacionPorDefecto, wxDefaultPosition, wxSize(45,-1),
		wxSP_ARROW_KEYS, VOLTAJE_MINIMO, VOLTAJE_MAXIMO, VOLTAJE_EN_REPOSO);	
	       
	  contenedorActivacion->Add(spnVoltajeActivacion, 0, 
	  	wxALL|wxALIGN_CENTER_VERTICAL|wxFIXED_MINSIZE, 5);
	  contenedorCentral->Add(contenedorActivacion, 1, wxEXPAND, 5);
	  
	  ConstruirCuadroDeDialogo (contenedorCentral);
}

void DialogoFotoSensor::getPropiedades ( Elemento* elemento )
{
	FotoSensor *foto = (FotoSensor*) elemento;
	TransferirDeNombreDeElementoAControl ( elemento );
	TransferirDeVoltajeASpin ( spnVoltajeReposo, 
								foto->getVoltajeSalidaReposo() );
	TransferirDeVoltajeASpin ( spnVoltajeActivacion, 
								foto->getVoltajeSalidaActivacion() );
}

void DialogoFotoSensor::setPropiedades ( Elemento* elemento )
{
	FotoSensor *foto = (FotoSensor*) elemento;
	TransferirDeControlANombreDeElemento (elemento);
	TransferirDeSpinAVoltaje (spnVoltajeReposo, 
								foto->getVoltajeSalidaReposo() );
	TransferirDeSpinAVoltaje ( spnVoltajeActivacion, 
								foto->getVoltajeSalidaActivacion() );
}

/************************Implementacion de gestion de eventos *************/
void DialogoFotoSensor::OnCReposoActualizado ( wxCommandEvent& evento )
{
	wxString cadena = chcLuzReposo->GetStringSelection();
	int codigo = cadena.Cmp ("activado");
	if ( codigo==0)
	{
		//wxLogMessage ("Activado!");
		chcLuzActivacion->SetSelection (1);
	}
	else 
	{
		//wxLogMessage ("Desactivado!");
		chcLuzActivacion->SetSelection (0);
	}
}

void DialogoFotoSensor::OnCActivacionActualizado ( wxCommandEvent& evento )
{
	wxString cadena = chcLuzActivacion->GetStringSelection();
	int codigo = cadena.Cmp ("activado");
	if (codigo==0)
	{
		//wxLogMessage ("Activado!");
		chcLuzReposo->SetSelection (1);
	}
	else 
	{
		//wxLogMessage ("Desactivado!");
		chcLuzReposo->SetSelection (0);
	}
}


BEGIN_EVENT_TABLE(DialogoFotoSensor, wxDialog)
		EVT_CHOICE	 ( ID_LUZ_REPOSO_FOTOSENSOR, DialogoFotoSensor::OnCReposoActualizado )
		EVT_CHOICE	 ( ID_LUZ_ACTIVACION_FOTOSENSOR, DialogoFotoSensor::OnCActivacionActualizado )
END_EVENT_TABLE()
