#include "dialogoxml.h"
#include "wx/file.h"
IMPLEMENT_CLASS (DialogoXML, DialogoXMLGenerado)
DialogoXML::DialogoXML (wxWindow *padre) : 
	DialogoXMLGenerado ( padre, -1, "Vista XML")
{
}


void DialogoXML::MostrarStringXML (wxString& xml)
{
	txtXML->WriteText (xml);
}

void DialogoXML::OnGuardar(wxCommandEvent& evento)
{
//	wxMessageBox ("Has pulsado el boton");
	wxString titulo = wxT("Guardar como...");
	wxString extensiones =
	   wxT("Ficheros XML (*.xml)|*.xml");
	wxString directorio(".");
	wxString nombrePorDefecto = wxEmptyString;
	
	wxFileDialog dialogo (this, titulo, directorio, 
		nombrePorDefecto, extensiones, wxSAVE);
	
	if (dialogo.ShowModal() == wxID_OK)
	{
		wxString path = dialogo.GetPath();
		wxLogMessage (wxString("Salvando en")+path);
		/*	Se almacena en el fichero si se puede */
		bool seAlmaceno = SalvarXML (path);
		if (seAlmaceno) wxLogMessage ("Salvado");
		this->EndModal(ID_GUARDAR);
	}
} /*Fin de OnGuardar */

bool DialogoXML::SalvarXML (wxString nombreDeFichero)
{
	wxFile fichero(nombreDeFichero.c_str(), wxFile::write);
	if ( !fichero.IsOpened())
	{
		/*Si no se pudo abrir salimos */
		return false;
	}
	/*	Hay que hacer estos hack porque la clase wxFile exige
		que se le pase un puntero a void con los datos que
		tiene que grabar */
	wxString texto = txtXML->GetValue();
	const void* datos = (void*)(texto.c_str());
	int longitudDatos = texto.Len();
	fichero.Write (datos, longitudDatos);
	fichero.Close();
	return true;
} /* Fin de SalvarXML*/
BEGIN_EVENT_TABLE (DialogoXML, DialogoXMLGenerado)
	EVT_BUTTON ( ID_GUARDAR,	DialogoXML::OnGuardar)
END_EVENT_TABLE ()
