#include "biestablevisual.h"

BiestableVisual::BiestableVisual()
{	
	/*	El bitmap ya ha sido
		creado en el constructor de la clase padre ElementoVisual,
		por lo que aqui podemos cargarlo sin preocuparnos de reservar */
		
		wxString ficheroIcono ("iconos/Biestable.xpm");
		bitmapEnPantalla.LoadFile (ficheroIcono, TIPO_ICONOS);

		Voltaje* activar_R			=	new Voltaje(5.0);
		Voltaje* desactivar_R		=	new Voltaje(0.0);	
		Voltaje* activar_S			=	new Voltaje(5.0);
		Voltaje* desactivar_S		=	new Voltaje(0.0);
		
		Voltaje* activar_Q			=	new Voltaje(5.0);
		Voltaje* desactivar_Q		=	new Voltaje(0.0);
		Voltaje* activar_Qneg		=	new Voltaje(5.0);
		Voltaje* desactivar_Qneg	=	new Voltaje(0.0);
		
		SetNombre ("Biestable");
		elementoEnvuelto = new Biestable ( 
			activar_R, desactivar_R, activar_S, 	desactivar_S,
			activar_Q, desactivar_Q, activar_Qneg,	desactivar_Qneg);
//		wxLogMessage ("El nombre es ahora " + nombreDelElementoVisual);
}

void BiestableVisual::setElementoEnvuelto (Elemento* elementoPasado)
{
	wxLogMessage ("---BiestableVisual::setElementoEnvuelto---");
	ElementoVisual::setElementoEnvuelto (elementoPasado);
	Biestable* biestable 	= dynamic_cast<Biestable*> (elementoPasado);
	this->elementoEnvuelto	= biestable;
	senalReposo	=biestable->getEntradaReposoR();
	senalActivacion = biestable->getActivacionR();
	
	/* Aqui no hay seales de reposo ni activacion */
}
void BiestableVisual::manejarEntrada (Senal* s, int posicion)
{
	wxLogMessage ("Se ha modificado la entrada del biestable");
}


Dialogo* BiestableVisual::FabricarDialogo()
{
	return new DialogoBiestable();
}

int	BiestableVisual::ElegirSalidaDeEmisor()
{	
	/* Esta es la salida por defecto */
	DialogoEleccion d(NULL);
	map <string, int> salidas;
	salidas = elementoEnvuelto->getNombreSalidas();
	d.CargarDatos (salidas);
	d.SetTipoDeDialogo (DIALOGO_SALIDAS);
	d.SetNombre (wxString(nombreDelElementoVisual));
	if (d.ShowModal() == ID_OK)
	{
		wxString eleccion	 	= d.GetSenalElegida();
		const char* intermedia 	= eleccion.c_str();
		string salidaElegida (intermedia);
//		wxLogMessage ("Se eligio %s", salidaElegida.c_str());
		return salidas[salidaElegida];
	}
	else {
		return ELECCION_CANCELADA;
	}
}

int BiestableVisual::ElegirEntradaDeReceptor()
{
	DialogoEleccion d(NULL);
	map <string, int> entradas;
	entradas = elementoEnvuelto->getNombreEntradas();
	d.CargarDatos (entradas);
	d.SetNombre (wxString(nombreDelElementoVisual));
	d.SetTipoDeDialogo (DIALOGO_ENTRADAS);
	
	if (d.ShowModal() == ID_OK)
	{
		wxString eleccion	 	= d.GetSenalElegida();
		const char* intermedia 	= eleccion.c_str();
		string entradaElegida (intermedia);
//		wxLogMessage ("Se eligio %s", entradaElegida.c_str());
		return entradas[entradaElegida];
	}
	else {
		return ELECCION_CANCELADA;
	}
}
