#include "fabricaelementosvisuales.h"

FabricaDeElementosVisuales::FabricaDeElementosVisuales()
{
		/* 	Se establece una correspondencia entre los nombres
		de los elementos y las constantes que los representan*/
	wxLogMessage ("---Fabrica de elementosVisuales---");	
	codigoDeElemento["pulsador"]	=PULSADOR;
	codigoDeElemento["electroiman"]	=ELECTROIMAN;
	codigoDeElemento["biestable"]	=BIESTABLE;
	codigoDeElemento["reed"]		=REED;
	codigoDeElemento["lampara"]		=LAMPARA;
	codigoDeElemento["temporizador"]=TEMPORIZADOR;
	codigoDeElemento["rele"]		=RELE;
	codigoDeElemento["biestable"]	=BIESTABLE;
	codigoDeElemento["zumbador"]	=ZUMBADOR;
	codigoDeElemento["fotosensor"]	=FOTOSENSOR;
	codigoDeElemento["motor"]		=MOTOR;
	codigoDeElemento["sistema"]		=SISTEMA;
	codigoDeElemento["contador"]	=CONTADOR;
	
}
ElementoVisual* FabricaDeElementosVisuales::CrearElementoVisual
		(int tipoDeElemento, wxWindow* padre)
{
	ElementoVisual* elementoADevolver=NULL;
	switch (tipoDeElemento)
	{
		case PULSADOR:
			{
				elementoADevolver = new PulsadorVisual();
				break;
			} /* Fin del case Pulsador */
		case ELECTROIMAN:
			{
				elementoADevolver = new ElectroimanVisual();
				break;
			} /* Fin del case Electroiman */
		case BIESTABLE:
			{
				elementoADevolver = new BiestableVisual();
				break;
			} /* Fin del case Biestable */
		case REED:
			{
				elementoADevolver = new ReedVisual();
				break;
			} /* Fin del case Zumbador */
		case TEMPORIZADOR:
			{
				elementoADevolver = new TemporizadorVisual();
				/* 	Cuidado, quiz al crear el temporizador y no poner
					la ventana padre o no aadirlo al vector temporizadores
					el temporizador no funcione correctamente */
				break;
			} /* Fin del case Temporizador */
		
		case ZUMBADOR:
			{
				elementoADevolver = new ZumbadorVisual();
				break;
			} /* Fin del case Zumbador */
			
		case RELE:
			{
				elementoADevolver = new ReleVisual();
				break;
			} /* Fin del case Rele */


		case CONTADOR:
			{
				elementoADevolver = new ContadorVisual();
				break;
			} /* Fin del case contador */

		case LAMPARA:
			{
				elementoADevolver = new LamparaVisual();
				break;
			}

		case FOTOSENSOR:
			{
				elementoADevolver = new FotosensorVisual();
				break;
			}
		case MOTOR:
			{
				elementoADevolver = new MotorVisual();
				break;
			}

		case SISTEMA:
			{
				wxLogMessage ("Creando sistema visual...");
				elementoADevolver = new SistemaVisual();
				wxLogMessage ("...creado sistema visual!");
				break;
			}
		default:
			{
				elementoADevolver=NULL;
				break;
			}
	} /*Fin del switch */
	assert (elementoADevolver!=NULL);
	elementoADevolver->SetVentanaPadre(padre);
	wxLogMessage ("---final de fabrica de elemento::Crear---");
	return elementoADevolver;
}

ElementoVisual* FabricaDeElementosVisuales::CrearElementoVisual
		(char* nombre, wxWindow* padre)
{
	wxLogMessage ("---FabricaDeElementosVisuales::CrearElemento Visual(%s)---",
		nombre);
	/* 	Y ahora devolvemos lo que devuelva el mtodo crear pero
		usando el codigo de elemento */
	string nombrecpp(nombre);
	map<string, int>::iterator i;
	i= codigoDeElemento.find(nombre);
	if (i==codigoDeElemento.end())
	{
		/*	Esto no debe ocurrir. El nombre de etiqueta pasado
			debe existir*/
			assert (false);
	}
	int codigo = codigoDeElemento[nombre];
	
	ElementoVisual* elementoADevolver = CrearElementoVisual (codigo, padre);
	assert (elementoADevolver!=NULL);
	
	return elementoADevolver;
}
