#include "panel_elementos.h"
#include "wx/wxprec.h"

PanelElementos::PanelElementos(wxWindow* id_ventana_padre, 
	int orientacion)
{
	this->orientacion		=	orientacion;
	this->id_ventana_padre	=	id_ventana_padre;
	
	vectorBotones.clear();	
	/* 	Estos ficheros incluyen imagenes en formato
		XPM, formato especfico para X11. Este formato
		es un fichero C con la definicin de la imagen
		en forma de array gigante. Examinar cualquiera
		de ellos para comprobar como se pueden "ver"
		las imagenes */
	#include "iconos/Pulsador2Inactivo.xpm"
	#include "iconos/RelojInactivo.xpm"
	#include "iconos/ReleInactivo.xpm"
	#include "iconos/Biestable.xpm"
	#include "iconos/ElectroimanInactivo.xpm"
	#include "iconos/ReedInactivo.xpm"
	#include "iconos/ContadorInactivo.xpm"
	#include "iconos/ZumbadorInactivo.xpm"
	#include "iconos/LamparaInactiva.xpm"
	#include "iconos/Fotosensor.xpm"
	#include "iconos/Motor.xpm"
	#include "iconos/SistemaIcono.xpm"
	// Construimos los bitmaps que iran en los botones
	wxBitmap bmpPulsador 		( Pulsador2Inactivo_xpm );
	wxBitmap bmpTemporizador 	( RelojInactivo_xpm );
	wxBitmap bmpRele 			( Releinactivo_xpm );
	wxBitmap bmpReed 			( ReedInactivo_xpm );
	wxBitmap bmpBiestable 		( Biestable );
	wxBitmap bmpElectroiman 	( ElectroimanInactivo_xpm );
	wxBitmap bmpContador 		( ContadorInactivo_xpm );
	wxBitmap bmpZumbador 		( ZumbadorInactivo_xpm );
	wxBitmap bmpLampara 		( LamparaInactiva_xpm );
	wxBitmap bmpFotosensor 		( Fotosensor );
	wxBitmap bmpMotor	 		( Motor );
	wxBitmap bmpSistema			( SistemaIcono );
	
	// Y construimos los botones que llevaran esas imagenes..
	botonPulsador		=		new wxBitmapButton (id_ventana_padre, 
		wxID_PULSADOR, bmpPulsador);
	vectorBotones.push_back(botonPulsador);
	
	botonTemporizador	=		new wxBitmapButton (id_ventana_padre, 
		wxID_TEMPORIZADOR, bmpTemporizador);
	vectorBotones.push_back(botonTemporizador);
	
	botonRele			=		new wxBitmapButton (id_ventana_padre,
		wxID_RELE, bmpRele);
	vectorBotones.push_back(botonRele);
		
	botonContador		=		new wxBitmapButton (id_ventana_padre,
		wxID_CONTADOR, bmpContador);
	vectorBotones.push_back(botonContador);
		
	botonElectroiman	=		new wxBitmapButton (id_ventana_padre,
		wxID_ELECTROIMAN, bmpElectroiman);
	vectorBotones.push_back(botonElectroiman);
		
	botonReed			=		new wxBitmapButton (id_ventana_padre,
		wxID_REED, bmpReed);
	vectorBotones.push_back(botonReed);
	
	botonZumbador		=		new wxBitmapButton (id_ventana_padre,
		wxID_ZUMBADOR, bmpZumbador);
	vectorBotones.push_back(botonZumbador);
		
	botonBiestable		=		new wxBitmapButton (id_ventana_padre,
		wxID_BIESTABLE, bmpBiestable);
	vectorBotones.push_back(botonBiestable);
	
	botonLampara		=		new wxBitmapButton (id_ventana_padre,
		wxID_LAMPARA, bmpLampara);
	vectorBotones.push_back(botonLampara);
	
	botonFotosensor		=		new wxBitmapButton (id_ventana_padre,
		wxID_FOTOSENSOR, bmpFotosensor);
	vectorBotones.push_back(botonFotosensor);
	
	botonSistema		=		new wxBitmapButton (id_ventana_padre,
		wxID_SISTEMA, bmpSistema);
	vectorBotones.push_back(botonSistema);
	
	botonMotor			=		new wxBitmapButton (id_ventana_padre,
		wxID_MOTOR, bmpMotor);
	vectorBotones.push_back(botonMotor);
	
	this->establecerToolTips();
	contenedorBotones =  contenedorIzquierdo = contenedorDerecho = NULL;
}

wxBoxSizer* PanelElementos::getContenedor()
{
	
	contenedorBotones	=	new wxBoxSizer	( wxHORIZONTAL );
	contenedorIzquierdo	=	new wxBoxSizer 	( orientacion);	
	contenedorDerecho	=	new wxBoxSizer	( orientacion );
	
		
	contenedorIzquierdo->Add(botonPulsador, 0, 
		wxALL | wxALIGN_CENTER, 5);
	contenedorIzquierdo->Add(botonElectroiman, 0, 
		wxALL | wxALIGN_CENTER, 5);
	contenedorIzquierdo->Add(botonReed, 0, 
		wxALL | wxALIGN_CENTER, 5);
	contenedorIzquierdo->Add(botonZumbador, 0, 
		wxALL | wxALIGN_CENTER, 5);
	contenedorIzquierdo->Add (botonLampara, 0,
		wxALL | wxALIGN_CENTER, 5);
	contenedorIzquierdo->Add (botonMotor, 0,
		wxALL | wxALIGN_CENTER, 5);
	
	contenedorDerecho->Add(botonContador, 0, 
		wxALL | wxALIGN_CENTER, 5);
	contenedorDerecho->Add(botonTemporizador, 0, 
		wxALL | wxALIGN_CENTER, 5);
	contenedorDerecho->Add(botonBiestable, 0, 
		wxALL | wxALIGN_CENTER, 5);
	contenedorDerecho->Add(botonRele, 0, 
		wxALL | wxALIGN_CENTER, 5);
	contenedorDerecho->Add(botonFotosensor, 0, 
		wxALL | wxALIGN_CENTER, 5);
	contenedorDerecho->Add(botonSistema, 0, 
		wxALL | wxALIGN_CENTER, 5);
	
	contenedorBotones->Add (contenedorIzquierdo, 0, wxEXPAND);
	contenedorBotones->Add (contenedorDerecho, 0, wxEXPAND);
	
	return contenedorBotones;
}

void PanelElementos::Habilitar()
{
	ActivarBotones(true);
	return ;
}

void PanelElementos::Deshabilitar()
{
	ActivarBotones(false);
	return ;
}
void PanelElementos::establecerToolTips()
{
	wxString tipBoton			=	wxString ("Pulsador");
	wxString tipRele			=	wxString ("Rele");
	wxString tipContador		= 	wxString ("Contador");
	wxString tipZumbador		= 	wxString ("Zumbador");
	wxString tipTemporizador	= 	wxString ("Temporizador");
	wxString tipBiestable		= 	wxString ("Biestable");
	wxString tipReed			=	wxString ("Reed");
	wxString tipElectroiman		=	wxString ("Electroiman");
	wxString tipLampara 		=	wxString ("Lampara");
	wxString tipMotor			=	wxString ("Motor");
	wxString tipSistema			=	wxString ("Subsistema");
	wxString tipFotosensor		=	wxString ("Fotosensor");
	
	botonPulsador->SetToolTip 		( tipBoton 			);
	botonRele->SetToolTip 			( tipRele 			);
	botonContador->SetToolTip		( tipContador 		);
	botonZumbador->SetToolTip		( tipZumbador 		);
	botonTemporizador->SetToolTip	( tipTemporizador 	);
	botonBiestable->SetToolTip		( tipBiestable 		);
	botonReed->SetToolTip			( tipReed 			);
	botonElectroiman->SetToolTip	( tipElectroiman 	);
	botonLampara->SetToolTip		( tipLampara 		);
	botonMotor->SetToolTip			( tipMotor 			);
	botonSistema->SetToolTip		( tipSistema 		);
	botonFotosensor->SetToolTip 	( tipFotosensor 	);
}

/* Si es true activa la botonera, si no, la desactiva*/
void PanelElementos::ActivarBotones(bool habilitar)
{
	vector<wxBitmapButton*>::iterator i;
	for ( 	i=vectorBotones.begin();
			i!=vectorBotones.end();
			i++ )
	{
		wxBitmapButton* botonActual = *i;
		botonActual->Enable(habilitar);
	}
}
