#include "reed.h"
#include "constantes.h"
#include <iostream>
using namespace std;
Reed::Reed (Magnetismo *mReposo, Voltaje* vReposo,
	Magnetismo *mActivacion, Voltaje* vActivacion )
{
	/*	Se copian los parametros fundamentales*/
	magReposo		=	mReposo;
	magActivacion	=	mActivacion;
	
	voltajeSalidaReposo		=	vReposo;
	voltajeSalidaActivacion	=	vActivacion;
	
	entradas[POS_ENTRADA] = mReposo;
	salidas [POS_SALIDA ] = vReposo;
	
}

Magnetismo* Reed::getMagnetismoReposo()
{
	return magReposo;
}

Magnetismo* Reed::getMagnetismoActivacion()
{
	return magActivacion;
}

Voltaje* Reed::getVoltajeSalidaReposo()
{
	return voltajeSalidaReposo;
}

Voltaje* Reed::getVoltajeSalidaActivacion()
{
	return voltajeSalidaActivacion;
}

int Reed::setEntrada (Senal* entrada, int posicion)
{
	Magnetismo* magEntrada=(Magnetismo*) entrada;
	
	if (magEntrada->getValor() == magReposo->getValor() )
	{
		entradas[POS_ENTRADA]	=	magReposo;
		salidas [POS_SALIDA]	=	voltajeSalidaReposo;
		return (Elemento::setEntrada(entrada,posicion) );	
	}
	
	if (magEntrada->getValor() == magActivacion->getValor() )
	{
		entradas[POS_ENTRADA]	=	magActivacion;
		salidas [POS_SALIDA]	=	voltajeSalidaActivacion;
		return (Elemento::setEntrada(entrada,posicion) );
	}
	
	/*	Entrada probablemente invalida!*/
	entradas[POS_ENTRADA]=magEntrada;
	return (Elemento::setEntrada(entrada,posicion));
}
void Reed::construir (DOMElement* nodo)
{
	obtenerDatosComunes (nodo);
		
	cout << "Recuperando magnetismos del reed\n";
	/* Obtenemos los valores de los distintos nodos */
	magReposo		= (Magnetismo*) getSenal 
						( MAGNETISMO, "entradareposo", 		nodo );
						
	magActivacion	= (Magnetismo*) getSenal 
						( MAGNETISMO, "entradaactivacion", 	nodo );
	
	cout << "Recuperando voltajes del reed\n";
	voltajeSalidaReposo 	= (Voltaje*) getSenal
						( VOLTAJE, "salidareposo", 			nodo );
						
	voltajeSalidaActivacion = (Voltaje*) getSenal
						( VOLTAJE, "salidaactivacion", 		nodo );
						
	entradas[POS_ENTRADA]	=magReposo;
	salidas[POS_SALIDA]		=voltajeSalidaReposo;					
}

NodoXML Reed::getXML ( DOMImplementation *impl )
{
	//etqElemento se hereda por parte de XMLSerializable
	//etqElemento = XMLString::transcode ("reed");
	
	DOMDocument* doc = impl->createDocument ();
	cout << "Creando documento base XML para reed\n";
	
	doc = getDocumentoXMLBase ( doc, "reed", nombreElemento, x, y );
	
	/*	Ahora aadimos a doc los elementos XML para indicar las distintas
		caractersticas. No se debe alterar el orden de creacin de elementos
		ya que el esquema exige dicho orden */
	cout << "Documento base reed creado\n";
	anadirElementoXML (doc, "entradareposo", 		
								getMagnetismoReposo() 			);
	anadirElementoXML (doc, "salidareposo", 		
								getVoltajeSalidaReposo()		);
	cout << "XML Reed:Reposo creados\n";
	anadirElementoXML (doc, "entradaactivacion",	
								getMagnetismoActivacion() 		);
	anadirElementoXML (doc, "salidaactivacion",		
								getVoltajeSalidaActivacion() 	);
	cout << "XML Reed:Activacion creada\n";
	DOMDocumentFragment* fragmento = doc->createDocumentFragment ();
	fragmento->appendChild ( doc->getDocumentElement() );
	return fragmento;
}
