#include "sistema.h"

/*	La parte de cdigo relativa al XML se ha sacado del fichero
	sistema.cpp porque el tamao del fichero se haca demasiado
	grande y resultaba difcil navegar por l a la hora de depurar */

NodoXML Sistema::getXML ( DOMImplementation *impl )
{	
	
	//etqElemento se hereda por parte de XMLSerializable	
	etqElemento = XMLString::transcode ( "sistema" );
	
	DOMDocument* nodo= impl->createDocument();
	
	DOMElement *raiz = nodo->createElement ( etqElemento );
	nodo->appendChild ( raiz );
	cout << "\tElemento sistema creado\n";
	cout << "\tEstableciendo atributos del sistema\n";
	raiz->setAttribute ( 
		C( "xmlns:xsi") , 
		C( "http://www.w3.org/2001/XMLSchema-instance" ) );
	raiz->setAttribute ( 
		C("xsi:noNamespaceSchemaLocation") , 
		C( "sistema2.xsd" ) );
	raiz->setAttribute ( C("x") , C( getX() ) );
	raiz->setAttribute ( C("y") , C( getY() ) );
	DOMElement*	elemNombreElemento 	= nodo->createElement  
										( C("nombresistema") );
	raiz->appendChild ( elemNombreElemento );
	DOMText*	txtElemento			= nodo->createTextNode 
										( C ( nombreElemento ) );
	elemNombreElemento->appendChild ( txtElemento );
//	cout << "Construida la base del sistema XML\n";
	/* Para cada elemento que hay en el vector de elementos extraemos el nodo
		XML que lo representa y lo aadimos a este documento XML */
//	cout << "El sistema contiene MaxElementos:" << MaxElementos << endl;
	map<string, Elemento*>::iterator i;
	for (	i=elementos.begin();
			i!=elementos.end();
			i++ )
	{
		Elemento* elemBucle=i->second;
		if (elemBucle!=NULL) {
//			cout << "Anadiendo el elemento " << elemento[i]->getNombreElemento() << endl;
			NodoXML n=elemBucle->getXML( impl );
//			cout << "El nodo n  tiene el tipo:" << n->getNodeType() << endl;		
//			cout << "El nodo nodo es de tipo:" << nodo->getNodeType()<< endl;		
//			cout << "El nodo raiz es de tipo:" << raiz->getNodeType()<< endl;		
			
			
			DOMNode* nodoImportado = nodo->importNode (n, true);
			raiz->appendChild (nodoImportado);
			
		}
	}
	
	/* 	Despues de almacenar los elementos almacenamos las relaciones
		que se dan entre los elementos de un sistema */	
	for (	i=elementos.begin();
			i!=elementos.end();
			i++ )
	{
		Elemento* elemBucle=i->second;
		if (elemBucle!=NULL) {
			elemBucle->getXMLSuscriptores( nodo );
		}
	}
	
//	for (int i=0;i<MAX_LONG_VECTOR_ENTRADAS;i++)
//	{
//		Conector *conector=conectores_entrada.at(i);
//		/*	Si no est libre es porque est conectado
//			a algun elemento, por lo que se le exige que
//			describa tal conexion */
//		if (!conector->estaLibre())
//		{
//			conector->getXMLSuscriptores ( nodo );
//		}
//	}
	/*	Devolver un DOMDocument es un proceso "pesado" segn la documentacin,
		la cual recomienda devolver DOMDocumentFragment. En este caso, 
		se devuelve un fragmento con el nodo creado */
	
	DOMDocumentFragment* fragmento = nodo->createDocumentFragment();
	fragmento->appendChild ( nodo->getDocumentElement() );
	
	return fragmento;
}

char* Sistema::getCadenaXML()
{
	XMLPlatformUtils::Initialize();
	static const XMLCh gLS[] = { chLatin_L, chLatin_S, chNull };
	DOMImplementation *impl = 
		DOMImplementationRegistry::getDOMImplementation(gLS);
	this->getXML (impl);

	DOMWriter* escritor = impl->createDOMWriter();
	const DOMNode*	nodoXMLSistema = this->getXML (impl);
	
	
	/*	Para que el Writer escriba el XML bien formateado (no imprescindible) */
	escritor->setFeature(XMLUni::fgDOMWRTFormatPrettyPrint, true);
	
	/*	La combinacin para nueva linea podra ser \r\n*/
	escritor->setNewLine (XMLString::transcode ("\n"));
	
	XMLCh*	cadenaXML = escritor->writeToString (*nodoXMLSistema);
	//Hay que sustituir esto y conseguir devolver el XML del sistema
//	string temp("<probando> </probando>");
//	return temp.c_str();

	char* cadena= XMLString::transcode (cadenaXML);
	XMLPlatformUtils::Terminate();
	return cadena;
}

