#include "unit++.h"
#include "zumbador.h"
#include "parser.h"

using namespace unitpp;

namespace
{
	
	class PruebaXMLZumbador : public suite
	{
		void PruebaValoresZumbador()
		{
			bool ficheroCorrecto = false;
			Parser* p=new Parser();
			Sistema* sistemaParseado;
			
			ficheroCorrecto	=	p->esValido ("xml\\zumbador.xml");
			if (ficheroCorrecto)
			{
				sistemaParseado=p->getSistema();
								
				/* 	El zumbador se llama ZumbadorA
					(no modificar los ficheros de test del
					directorio xml) */
				Zumbador* elementoProbado=(Zumbador*)
					sistemaParseado->getRefElementoPorNombre("ZumbadorA");
				/* Construimos los valores a mano...*/	
				
				Voltaje*  v1	=	new Voltaje  (0.0);
				Voltaje*  v2	=	new Voltaje  (4.0);
				Frecuencia* f1	=	new Frecuencia (0);
				Frecuencia* f2	=	new Frecuencia (15000);
				/* Estos son los valores que sacaremos del XML */
				
				Voltaje  *v;
				Voltaje  *w;
				Frecuencia* fReposoLeida;
				Frecuencia* fActivacionLeida;
				/* y comparo esos valores con los leidos del fichero...*/
				
				cout << "Extrayendo senales" << endl;			
				v=elementoProbado->getVoltajeReposo();
				w=elementoProbado->getVoltajeActivacion();
				cout << "Extraidos voltajes. Pasando a frecuencias...\n";
				fReposoLeida	=elementoProbado->getFrecuenciaReposo();
				fActivacionLeida=elementoProbado->getFrecuenciaActivacion();
				
				cout << "Frecuencias extraidas\n";
				/* 	Se comprueba si las seales construida y la leida
					del XML son iguales...*/
			
				assert_eq ("(XML) Zumbador:Voltaje en reposo",  
					v->getValor(), v1->getValor() );
					
				assert_eq ("(XML) Zumbador:Voltaje activacion", 
					w->getValor(), v2->getValor() );	
				cout << "Ok voltajes\n";
				assert_eq ("(XML) Zumbador:Frecuencia en reposo",
					f1->getValor(), fReposoLeida->getValor() );
				assert_eq ("(XML) Zumbador:Frecuencia en reposo",
					f2->getValor(), fActivacionLeida->getValor() );
				cout << "Intentando escritura\n";
				p->escribir(elementoProbado, 
					"xml-resultadoTest-xmlZumbador.xml");
				
				cout << "Finalizado testxmlzumbador\n";
			}	/* Fin del if que comprueba si el fichero es correcto */
			else {
				cout << "Fichero zumbador.xml no valido\n";
			}
		}
		
		public:
			PruebaXMLZumbador() : suite ("Prueba del XML de Zumbador")
			{
				add ("PruebaXMLZumbador", testcase (this,
					"PruebaXMLZumbador", 
					&PruebaXMLZumbador::PruebaValoresZumbador) );
				
				suite::main().add("PruebaXMLZumbador", this);
			}
	};
	PruebaXMLZumbador *prZumbador=new PruebaXMLZumbador();	
}
